package exercises;

import java.util.Scanner;
import java.util.Arrays;

/*
 * Last Homework
 * Question Posted on Facebook 
 */
public class Last_Homework_KaranSachdev_5935219_541 {

	public static int sequentialsearch(String[] name, String key) {
		int met = -1;
		for (int i = 0; i < name.length; i++) {
			if (name[i].equals(key)) {
				met = i;
				break;
			}
		}
		return met;
	}

	public static double mean(double[] arr) {
		double sum = 0;
		for (int i = 0; i < arr.length; i++) {
			sum = sum + arr[i];// sum += arr[i];
		}
		return sum / arr.length;
	}

	public static double median(double[] arr) {
		double temp[] = new double[arr.length];
		for (int i = 0; i < arr.length; i++) {
			temp[i] = arr[i];
		}
		Arrays.sort(temp);
		int l = arr.length;
		if (l % 2 == 1)
			return temp[1 / 2];
		else
			return (temp[1 / 2] + temp[(1 / 2) - 1]) / 2;
	}

	public static double mode(double[] arr) {
		double temp[] = new double[arr.length];
		for (int i = 0; i < temp.length - 1; i++) {
			temp[i] = arr[i];
		}
		Arrays.sort(temp);
		int freq = 1;
		int highest_freq = 1;
		double num1 = temp[0];
		double num2 = temp[0];
		for (int i = 1; i < temp.length - 1; i++) {
			if (num1 == temp[i]) {
				freq++;
			} else {
				freq = 1;
				num1 = temp[i];
			}
			if (freq > highest_freq) {
				highest_freq = freq;
				num2 = num1;
			}
		}
		return num2;
	}

	public static void displaylist(String[] name, double[] score) {
		System.out.println("Name	Score");
		for (int i = 0; i < name.length; i++)
			System.out.println(name[i] + "\t" + score[i]);
	}

	public static void higherThanAverage(String[] inputName, double[] inputScore) {
		for (int i = 0; i < 50; i++) {
			if (inputScore[i] > mean(inputScore)) {
				System.out.println(inputName[i] + " : " + inputScore[i]);
			}
		}
	}

	public static int menu() {
		Scanner in = new Scanner(System.in);
		System.out.println("***Menu***");
		System.out.println("Press 1 to Input Student full name and Score");
		System.out.println("Press 2 to Search");
		System.out.println("Press 3 to get the mean, mode and median of all the scores");
		System.out.println("Press 4 to get the score higher than mean");
		System.out.println("Press 5 to exit");
		System.out.print("Select a number: ");
		return in.nextInt();
	}

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		double[] inputScore = new double[50];
		String[] inputName = new String[50];
		int menu = 1;
		while (menu != 5) {
			menu = menu();
			if (menu == 1) {
				for (int i = 0; i < 50; i++) {
					System.out.print("Enter Fullname: ");
					inputName[i] = in.nextLine();
					System.out.print("Enter Total Score: ");
					String c = in.nextLine();
					double convert = Double.parseDouble(c);
					inputScore[i] = convert;
				}
				displaylist(inputName, inputScore);
			} else if (menu == 2) {
				System.out.print("Enter a name of a student you want to know the score of ==> ");
				String sName = in.nextLine();
				int index = sequentialsearch(inputName, sName);
				if (index != -1) {
					System.out.println(inputName[index] + " get the score, " + inputScore[index]);
				} else {
					System.out.println("Not found!");
				}
			} else if (menu == 3) {
				System.out.println("Mode of all the students = " + mode(inputScore));
				System.out.println("Median of all the students = " + median(inputScore));
				System.out.println("Mean of all the = " + mean(inputScore));
			} else if (menu == 4) {
				System.out.println("Students Scores that are higher than average= ");
				higherThanAverage(inputName, inputScore);
			}
		}
		in.close();
	}
}
